import { registerMicroApps, setDefaultMountApp, start } from 'qiankun'
import { initGlobalState } from 'qiankun'
import state from './qiankunState/state'

const actions = initGlobalState(state)

// actions.onGlobalStateChange((state, prev) => {
//   console.log("父层变化：",state, prev)
//   // window.qiankunState = state;
// })

export const microApps = {
  childHealth: {
    // - 必选，微应用的名称，微应用之间必须确保唯一
    name: 'app-content',
    // - 必选，微应用的入口
    entry: '//jsek.bnuic.com/books/book/childHealth',
    // - 必选，微应用的容器节点的选择器或者 Element 实例
    container: '#container',
    // - 必选，微应用的激活规则
    //支持直接配置字符串或字符串数组，如 activeRule: '/app1' 或 activeRule: ['/app1', '/app2']，当配置为字符串时会直接跟 url 中的路径部分做前缀匹配，匹配成功表明当前应用会被激活。
    //支持配置一个 active function 函数或一组 active function。函数会传入当前 location 作为参数，函数返回 true 时表明当前微应用会被激活。如 location => location.pathname.startsWith('/app1')。
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
    //loader - (loading: boolean) => void - 可选，loading 状态发生变化时会调用的方法。
  },
  artAndDance: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/artAndDance',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  english: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/english',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  lifeCare: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/lifeCare',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  sportsAndHealth: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/sportsAndHealth',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  mathBook: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/mathBook',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  artAndDrama: {
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/artAndDrama',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  civilAviation:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/civilAviation',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  civilServices:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/civilServices',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  meetingPlanners:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/meetingPlanners',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  aviationBasicSkills:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/aviationBasicSkills',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  aviationSafety:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/aviationSafety',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  aviationEtiquette:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/aviationEtiquette',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  toddlerGameImplementation:{
    name: 'app-content',
    entry: '//jsek.bnuic.com/books/book/toddlerGameImplementation',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  botany:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/botany',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  aurturingAndEducationAged0to3:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/aurturingAndEducationAged0to3',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  childcareInstitutionsManagement:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/childcareInstitutionsManagement',
    container: '#container',
    activeRule: '/home' //匹配所有以/subPath开头的为子应用
  },
  preschoolGameGuidance:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/preschoolGameGuidance',
    container: '#container',
    activeRule: '/home'
  },
  kindergartenLanguageActivity:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/kindergartenLanguageActivity',
    container: '#container',
    activeRule: '/home'
  },
  preschoolEvaluation:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/preschoolEvaluation',
    container: '#container',
    activeRule: '/home'
  },
  preschoolBasicKnowledge:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/preschoolBasicKnowledge',
    container: '#container',
    activeRule: '/home'
  },
  kindergartenActivitiesDesignGuidance:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/kindergartenActivitiesDesignGuidance',
    container: '#container',
    activeRule: '/home'
  },
  policiesAndRegulations:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/policiesAndRegulations',
    container: '#container',
    activeRule: '/home'
  },
  OralAndBroadcasting:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/OralAndBroadcasting',
    container: '#container',
    activeRule: '/home'
  },
  cognitiveLanDevEduAges0to3:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/cognitiveLanDevEduAges0to3', 
    container: '#container',
    activeRule: '/home'
  },
  toddlerSportsSafetyProtection:{
    name: 'app-content',
    entry: '//182.92.203.7:3007/books/book/toddlerSportsSafetyProtection',
    container: '#container',
    activeRule: '/home'
  }
}

window.qiankunActions = actions

export default actions

// actions.offGlobalStateChange()

// 乾坤提供的子应用生命周期钩子  可用于加载loading
// const mount = {
//   beforeLoad: () => {
//     //开始加载loading
//     console.log('子应用加载前')
//   },
//   beforeMount: () => {
//     console.log('子应用挂载前')
//   },
//   afterMount: () => {
//     //结束加载loading
//     console.log('子应用挂载后')
//   },
//   beforeUnmount: () => {
//     console.log('子应用卸载前')
//   },
//   afterUnmount: () => {
//     console.log('子应用卸载后')
//   }
// }
//注册子应用
// registerMicroApps(microApps, mount)
//设置默认启动子应用
// setDefaultMountApp('/home')
//启动qiankun | 不可重复启动 | 如果子应用入口在app.vue里可以在这启动否则会报错找不到子应用结点
// start()
